from typing import Generic, TypeVar

__all__ = ('Reduce',)

Element = TypeVar('Element')
Out = TypeVar('Out')


class Reduce(Generic[Element, Out]):
    def __init__(self, initial: Out):
        self.initial = initial

    async def reduce(self, out: Out, element: Element) -> Out:
        raise NotImplementedError

    async def merge(self, left: Out, right: Out) -> Out:
        raise NotImplementedError
