from typing import Generic, TypeVar

__all__ = ('SequenceDispatch',)

Element = TypeVar('Element')
Out = TypeVar('Out')


class SequenceDispatch(Generic[Element, Out]):
    async def on_first(self, element: Element) -> Out:
        raise NotImplementedError

    async def on_last(self, element: Element) -> Out:
        raise NotImplementedError

    async def on_pair(self, previous: Element, element: Element) -> Out:
        raise NotImplementedError
