from typing import Generic, TypeVar

from rainbowadn.core import *
from rainbowadn.flow.core import *

__all__ = ('Verification',)

Verified = TypeVar('Verified')


class Verification(
    Mapper[Verified, bool],
    Generic[Verified]
):
    async def map(self, element: Verified) -> bool:
        assert_true(await self.verify(element))
        return True

    async def verify(self, element: Verified) -> bool:
        raise NotImplementedError

    def as_mapper(self) -> Mapper[Verified, bool]:
        return self
